﻿/**
* Open Bound Classes command by Ryan Matsikas. Oct 31, 2004
* Visit www.gskinner.com for documentation, updates and more free code.
*
* Credit for the idea goes to Tony of Teknision.com
*
* Notice: All JSFL commands have the ability to damage your files. It is recommended
* that you run these commands on copies of your files. You take all responsibility
* for any problems or damage incurred directly or indirectly from running this command.
*
* You may distribute this code freely, as long as this comment block remains intact.
*/

var classPaths = ["./classes","$(LocalData)/Classes"]; // would be nice if jsfl could do this

function openBoundClasses() {
	var dom = fl.getDocumentDOM();
	var found = true;
	if (dom != null) {
		if (dom.path == undefined) { alert("You must save your .fla to use this command."); return; };
		var relPath = dom.path.split(dom.name).join("");
		var items = dom.library.getSelectedItems();
		var len = items.length;
		for (var i = 0; i<len; i++) {
			var ocLoc = items[i].linkageClassName;
			if ((ocLoc != undefined) && (String(ocLoc).length)) {
				var cLoc = ocLoc.split(".").join("/")+".as";
				var cLen = classPaths.length;
				var scriptPath;
				for (var j = 0; j<cLen; j++) {
					var path = classPaths[j];
					if (path.indexOf("../") != -1) {
						var newPath = recurseURI(relPath, path);
						if (newPath != -1) {
							fl.trace(relPath+" : "+newPath)
								scriptPath = _encodeURI(newPath)+cLoc;
							}
					} else if (path.indexOf(".") != -1) {
						if (path.indexOf("./") != -1) {
							var newPath = path.substr(2, path.length)+"/";
							scriptPath = _encodeURI(relPath+newPath+cLoc);
						} else {
							scriptPath = _encodeURI(relPath+cLoc);
						}
					} else if (path.indexOf("$(LocalData)") != -1) {
						if (path.indexOf("/") != -1) {
							var dir = path.substring(13, path.length);
							scriptPath = (path.split("$(LocalData)").join(fl.configURI)+dir+cLoc)
						} else {
							scriptPath = (path.split("$(LocalData)").join(fl.configURI)+cLoc)
						}
					} else {
						scriptPath = path+cLoc;
					}
					if (FLfile.exists(scriptPath)) {
						found = true;
						fl.openScript(scriptPath);
						break;
					} else { found = false; }
				}
				if (!found) { alert(ocLoc+" not found!") };
			}
		}
	}
}
function recurseURI(p_uri, p_steps) {
	var uriSteps = p_uri.split("\\");
	var uriLen = uriSteps.length;
	var stepCount = p_steps.split("../").length;
	var lastIndex = p_steps.lastIndexOf("../");
	var path = "";
	if ((lastIndex+3) != p_steps.length) {
		path = (p_steps.substr((lastIndex+3), p_steps.length))
	}
	if (stepCount<uriLen) {
		var newURI = [];
		var len = uriSteps.length-stepCount;
		for (var i = 0; i<len; i++) {
			newURI.push(uriSteps[i]);
		}
		return (newURI.join("\\")+"\\"+path);
	}
	return -1;
}
function _encodeURI(p_uri) { return "file:///"+p_uri.split("\\").join("/"); }

openBoundClasses();
